Package org.optaplanner.core.impl.phase.scope

## Class AbstractMoveScope<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.phase.scope.AbstractMoveScope<Solution_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
  Direct Known Subclasses:
    `ConstructionHeuristicMoveScope`, `LocalSearchMoveScope`

      public abstract class AbstractMoveScope<Solution_>
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Move<Solution_>` | `move` |
    `protected int` | `moveIndex` |
    `protected Score<?>` | `score` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractMoveScope​(int moveIndex, Move<Solution_> move)` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Move<Solution_>` | `getMove()` |
    `int` | `getMoveIndex()` |
    `<Score_ extends Score<Score_>> Score_` | `getScore()` |
    `<Score_ extends Score<Score_>> InnerScoreDirector<Solution_,​Score_>` | `getScoreDirector()` |
    `int` | `getStepIndex()` |
    `abstract AbstractStepScope<Solution_>` | `getStepScope()` |
    `Random` | `getWorkingRandom()` |
    `Solution_` | `getWorkingSolution()` |
    `<Score_ extends Score<Score_>> void` | `setScore​(Score_ score)` |
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### moveIndex

          protected final int moveIndex

    - #### move

          protected final Move<Solution_> move

    - #### score

          protected Score<?> score

  - ### Constructor Detail

    - #### AbstractMoveScope

          public AbstractMoveScope​(int moveIndex,
                                   Move<Solution_> move)

  - ### Method Detail

    - #### getStepScope

          public abstract AbstractStepScope<Solution_> getStepScope()

    - #### getMoveIndex

          public int getMoveIndex()

    - #### getMove

          public Move<Solution_> getMove()

    - #### getScore

          public <Score_ extends Score<Score_>> Score_ getScore()

    - #### setScore

          public <Score_ extends Score<Score_>> void setScore​(Score_ score)

    - #### getStepIndex

          public int getStepIndex()

    - #### getScoreDirector

          public <Score_ extends Score<Score_>> InnerScoreDirector<Solution_,​Score_> getScoreDirector()

    - #### getWorkingSolution

          public Solution_ getWorkingSolution()

    - #### getWorkingRandom

          public Random getWorkingRandom()

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`